<template>
  <nav class="navbar navbar-expand-lg">
  <div class="nav-bar container-fluid">
    <div>
      <!-- LOGO -->
      <router-link to="/"><img id="logoImage" src="../assets/koala.svg" alt="DropBearTable logo"></router-link>
      <router-link to="/" id="brandName" class="navbar-brand">DropBearTable</router-link>
    </div>
    <div id="menu">
      <!-- MENU LIST -->
      <div>
        <button class="nav-btn" @click="onClickLogIn" v-if="showLogInBtn">Log In</button>
        <router-link :to="{ name: 'Bookings' }"><button class="nav-btn" v-if="showBookingBtn">My Bookings</button></router-link>
        <button @click="onClickContact" id="contactUsLink" class="nav-btn">Contact Us</button>
        <router-link :to="{ name: 'Graph' }"><button class="nav-btn">Graph</button></router-link>
      </div>

      <HourglassIcon v-if="showHourglass" />

      <!-- LOG IN FORM -->
      <ModalWindow v-if="showLogIn"
                   @close="showLogIn = false"
                   :title="login_window.title"
                   :body="login_window.body">
          <div class="form-floating mb-3">
            <input v-model="email" type="email" class="form-control" id="emailInput" placeholder="name@example.com">
            <label for="emailInput" class="form-label">Email address</label>
          </div>
          <!-- Password Input -->
          <div class="form-floating">
            <input v-model="password" type="password" class="form-control" id="passwordInput" placeholder="Password">
            <label for="passwordInput">Password</label>
          </div>
          <!-- Log In Submit Button -->
          <button type="submit" id="logInSubmitBtn" class="btn btn-light" @click="submit">Submit</button>
          <div v-if="showInvalid" id="invalidNote" class="invalid-entry">Email or password entered is invalid. (NOTE: Login with "name@example.com" and "password")</div>
      </ModalWindow>
    </div>
  </div>
  </nav>
</template>

<script>
import ModalWindow from "./ModalWindow"
import HourglassIcon from "./HourglassIcon";

export default {
  name: "NavBar",
  components: {
    HourglassIcon,
    ModalWindow
  },
  data() {
    return {
      email: null,
      password: null,
      login_window: {
        title: "Log In",
        body: "Please log in to view your reservations."
      },
      showLogInBtn: true,
      showLogIn: false,
      showInvalid: false,
      showBookingBtn: false,
      showHourglass: false
    }
  },
  computed: {
    get_email() {
      return this.email
    },
    get_password() {
      return this.password
    }
  },
  methods: {
    onClickLogIn() {
      this.showLogIn = !this.showLogIn
    },
    onClickContact() {
      document.getElementById("contactUsDiv").scrollIntoView();
    },
    submit() {
      // If incorrect credentials, show error message
      if (this.get_email !== "name@example.com" || this.get_password !== "password") {
        this.showInvalid = true
      }

      // Close error message and show bookings button with successful login
      else {
        this.showHourglass = !this.showHourglass;
        this.showLogIn = !this.showLogIn;

        if (this.showInvalid === true) {
          this.showInvalid = !this.showInvalid
        }

        setTimeout( () => {
          this.showHourglass = false;
          this.showLogInBtn = false;
          this.showBookingBtn = true;
        }, 3000)
      }
    }
  }
}
</script>

<style scoped>
.btn {
  color: #584141;
  background-color: #f3f3f3;
  border-color: #c6c6c6;
}

.btn-light:hover {
  background-color: #a97c7c;
  color: #f6ede3;
}

.nav-btn {
  padding: 0.2rem;
  margin: 0 0.1rem;
  font-size: small;
  color: #584141;
  outline: none;
  background-color: #faf2ee;
  border: 0.1em solid #bf9e9e;
}

.nav-btn:active {
  padding: 0.2rem;
  margin: 0 0.1rem;
  font-size: small;
  color: #f6ede3;
  outline: none;
  background-color: #a97c7c;
}

.invalid-entry {
  display: block;
  color: #d02b2b;
  font-size: small;
  margin-top: 1rem;
}

button:hover {
  color: #f6ede3;
  background-color: #a97c7c;
}

#logoImage {
  height: 3rem;
  width: 3rem;
}

#brandName {
  font-family: Georgia, serif;
  color: #886565;
}

#logInSubmitBtn {
  margin-top: 2rem;
}
</style>